#ifndef LAYOUT_AWT_VCLXPROXY_HXX
#define LAYOUT_AWT_VCLXPROXY_HXX

#include <com/sun/star/awt/XDevice.hpp>
#include <com/sun/star/lang/XTypeProvider.hpp>
#include <com/sun/star/lang/XUnoTunnel.hpp>

#include <com/sun/star/awt/XWindow.hpp>
#include <com/sun/star/awt/XWindow2.hpp>
#include <com/sun/star/awt/XVclWindowPeer.hpp>
#include <com/sun/star/awt/XLayoutConstrains.hpp>
#include <com/sun/star/awt/XView.hpp>
#include <com/sun/star/awt/XPointer.hpp>
#include <com/sun/star/awt/XGraphics.hpp>
#include <com/sun/star/beans/XPropertyChangeListener.hpp>
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#include <com/sun/star/accessibility/XAccessible.hpp>
#include <com/sun/star/accessibility/XAccessibleContext.hpp>
#include <com/sun/star/awt/XDockableWindow.hpp>

#include <com/sun/star/awt/XImageConsumer.hpp>
#include <com/sun/star/awt/XButton.hpp>
#include <com/sun/star/awt/XToggleButton.hpp>

#include <cppuhelper/weak.hxx>

// This is a generic proxy class - override it to wrap &
// extend these interfaces
// Warning: this is of course not complete ...
class VCLXProxy :
    // VCLXDevice
    public com::sun::star::awt::XDevice,
    public com::sun::star::lang::XTypeProvider,
    public com::sun::star::lang::XUnoTunnel,
    // VCLXWindow
    public com::sun::star::awt::XWindow2,
    public com::sun::star::awt::XVclWindowPeer,
    public com::sun::star::awt::XLayoutConstrains,
    public com::sun::star::awt::XView,
    public com::sun::star::awt::XDockableWindow,
    public com::sun::star::accessibility::XAccessible,
    public com::sun::star::lang::XEventListener,
    public com::sun::star::beans::XPropertySetInfo,
    // VCLXImageConsumer
    public com::sun::star::awt::XImageConsumer,
    // VCLXButton
    public com::sun::star::awt::XButton,
    public com::sun::star::awt::XToggleButton,
    public ::cppu::OWeakObject
{
    // VCLXDevice
    com::sun::star::uno::Reference< com::sun::star::awt::XDevice > mxDevice;
    com::sun::star::uno::Reference< com::sun::star::lang::XTypeProvider > mxTypeProvider;
    com::sun::star::uno::Reference< com::sun::star::lang::XUnoTunnel > mxUnoTunnel;

    // VCLXWindow
    com::sun::star::uno::Reference< com::sun::star::lang::XComponent > mxComponent;
    com::sun::star::uno::Reference< com::sun::star::awt::XWindow > mxWindow;
    com::sun::star::uno::Reference< com::sun::star::awt::XWindow2 > mxWindow2;
    com::sun::star::uno::Reference< com::sun::star::awt::XWindowPeer > mxWindowPeer;
    com::sun::star::uno::Reference< com::sun::star::awt::XVclWindowPeer > mxVclWindowPeer;
    com::sun::star::uno::Reference< com::sun::star::awt::XLayoutConstrains > mxLayoutConstrains;
    com::sun::star::uno::Reference< com::sun::star::awt::XView > mxView;
    com::sun::star::uno::Reference< com::sun::star::awt::XDockableWindow > mxDockableWindow;
    com::sun::star::uno::Reference< com::sun::star::accessibility::XAccessible > mxAccessible;
    com::sun::star::uno::Reference< com::sun::star::lang::XEventListener > mxEventListener;
    com::sun::star::uno::Reference< com::sun::star::beans::XPropertySetInfo > mxPropertySetInfo;
    com::sun::star::uno::Reference< com::sun::star::awt::XItemEventBroadcaster > mxItemEventBroadcaster;

    // VCLXImageConsumer
    com::sun::star::uno::Reference< com::sun::star::awt::XImageConsumer > mxImageConsumer;

    // VCLXButton
    com::sun::star::uno::Reference< com::sun::star::awt::XButton > mxButton;
    com::sun::star::uno::Reference< com::sun::star::awt::XToggleButton > mxToggleButton;

public:
    VCLXProxy( com::sun::star::uno::Reference< com::sun::star::uno::XInterface > xObject );

    // XInterface
    virtual void SAL_CALL acquire() throw() { ::cppu::OWeakObject::acquire(); }
    virtual void SAL_CALL release() throw() { ::cppu::OWeakObject::release(); }
    virtual com::sun::star::uno::Any SAL_CALL queryInterface( const com::sun::star::uno::Type & rType ) throw (com::sun::star::uno::RuntimeException);

    // lang::XComponent
    virtual void SAL_CALL dispose() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& aListener ) throw (com::sun::star::uno::RuntimeException);

    // awt::XWindowPeer
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XToolkit > SAL_CALL getToolkit() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setPointer( const com::sun::star::uno::Reference< com::sun::star::awt::XPointer >& Pointer ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setBackground( ::sal_Int32 Color ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL invalidate( ::sal_Int16 Flags ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL invalidateRect( const com::sun::star::awt::Rectangle& Rect, ::sal_Int16 Flags ) throw (com::sun::star::uno::RuntimeException);

    // awt::XDevice
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XGraphics > SAL_CALL createGraphics() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XDevice > SAL_CALL createDevice( ::sal_Int32 nWidth, ::sal_Int32 nHeight ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::DeviceInfo SAL_CALL getInfo() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Sequence< com::sun::star::awt::FontDescriptor > SAL_CALL getFontDescriptors() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XFont > SAL_CALL getFont( const com::sun::star::awt::FontDescriptor& aDescriptor ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XBitmap > SAL_CALL createBitmap( ::sal_Int32 nX, ::sal_Int32 nY, ::sal_Int32 nWidth, ::sal_Int32 nHeight ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XDisplayBitmap > SAL_CALL createDisplayBitmap( const com::sun::star::uno::Reference< com::sun::star::awt::XBitmap >& Bitmap ) throw (com::sun::star::uno::RuntimeException);

    // lang::XTypeProvider
    virtual com::sun::star::uno::Sequence< com::sun::star::uno::Type > SAL_CALL getTypes() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Sequence< ::sal_Int8 > SAL_CALL getImplementationId() throw (com::sun::star::uno::RuntimeException);

    // lang::XUnoTunnel
    virtual ::sal_Int64 SAL_CALL getSomething( const com::sun::star::uno::Sequence< ::sal_Int8 >& aIdentifier ) throw (com::sun::star::uno::RuntimeException);

    // awt::XWindow2
    virtual void SAL_CALL setOutputSize( const com::sun::star::awt::Size& aSize ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::Size SAL_CALL getOutputSize() throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isVisible() throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isActive() throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isEnabled() throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL hasFocus() throw (com::sun::star::uno::RuntimeException);

    // awt::XWindow
    virtual void SAL_CALL setPosSize( ::sal_Int32 X, ::sal_Int32 Y, ::sal_Int32 Width, ::sal_Int32 Height, ::sal_Int16 Flags ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::Rectangle SAL_CALL getPosSize() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setVisible( ::sal_Bool Visible ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setEnable( ::sal_Bool Enable ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setFocus() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addWindowListener( const com::sun::star::uno::Reference< com::sun::star::awt::XWindowListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeWindowListener( const com::sun::star::uno::Reference< com::sun::star::awt::XWindowListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addFocusListener( const com::sun::star::uno::Reference< com::sun::star::awt::XFocusListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeFocusListener( const com::sun::star::uno::Reference< com::sun::star::awt::XFocusListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addKeyListener( const com::sun::star::uno::Reference< com::sun::star::awt::XKeyListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeKeyListener( const com::sun::star::uno::Reference< com::sun::star::awt::XKeyListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addMouseListener( const com::sun::star::uno::Reference< com::sun::star::awt::XMouseListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeMouseListener( const com::sun::star::uno::Reference< com::sun::star::awt::XMouseListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addMouseMotionListener( const com::sun::star::uno::Reference< com::sun::star::awt::XMouseMotionListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeMouseMotionListener( const com::sun::star::uno::Reference< com::sun::star::awt::XMouseMotionListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addPaintListener( const com::sun::star::uno::Reference< com::sun::star::awt::XPaintListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removePaintListener( const com::sun::star::uno::Reference< com::sun::star::awt::XPaintListener >& xListener ) throw (com::sun::star::uno::RuntimeException);

    // awt::XVclWindowPeer
    virtual ::sal_Bool SAL_CALL isChild( const com::sun::star::uno::Reference< com::sun::star::awt::XWindowPeer >& Peer ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setDesignMode( ::sal_Bool bOn ) throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isDesignMode() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL enableClipSiblings( ::sal_Bool bClip ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setForeground( ::sal_Int32 Color ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setControlFont( const com::sun::star::awt::FontDescriptor& aFont ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL getStyles( ::sal_Int16 nType, com::sun::star::awt::FontDescriptor& Font, ::sal_Int32& ForegroundColor, ::sal_Int32& BackgroundColor ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const com::sun::star::uno::Any& Value ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw (com::sun::star::uno::RuntimeException);

    // awt::XLayoutConstrains
    virtual com::sun::star::awt::Size SAL_CALL getMinimumSize() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::Size SAL_CALL getPreferredSize() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::Size SAL_CALL calcAdjustedSize( const com::sun::star::awt::Size& aNewSize ) throw (com::sun::star::uno::RuntimeException);

    // awt::XView
    virtual ::sal_Bool SAL_CALL setGraphics( const com::sun::star::uno::Reference< com::sun::star::awt::XGraphics >& aDevice ) throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::awt::XGraphics > SAL_CALL getGraphics() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::awt::Size SAL_CALL getSize() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL draw( ::sal_Int32 nX, ::sal_Int32 nY ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setZoom( float fZoomX, float fZoomY ) throw (com::sun::star::uno::RuntimeException);

    // awt::XDockableWindow
    virtual void SAL_CALL addDockableWindowListener( const com::sun::star::uno::Reference< com::sun::star::awt::XDockableWindowListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeDockableWindowListener( const com::sun::star::uno::Reference< com::sun::star::awt::XDockableWindowListener >& xListener ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL enableDocking( ::sal_Bool bEnable ) throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isFloating() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setFloatingMode( ::sal_Bool bFloating ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL lock() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL unlock() throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isLocked() throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL startPopupMode( const com::sun::star::awt::Rectangle& WindowRect ) throw (com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL isInPopupMode() throw (com::sun::star::uno::RuntimeException);

    // accessibility::XAccessible
    virtual com::sun::star::uno::Reference< com::sun::star::accessibility::XAccessibleContext > SAL_CALL getAccessibleContext() throw (com::sun::star::uno::RuntimeException);

    // lang::XEventListener
    virtual void SAL_CALL disposing( const com::sun::star::lang::EventObject& Source ) throw (com::sun::star::uno::RuntimeException);

    // beans::XPropertySetInfo
    virtual com::sun::star::uno::Sequence< com::sun::star::beans::Property > SAL_CALL getProperties() throw (com::sun::star::uno::RuntimeException);
    virtual com::sun::star::beans::Property SAL_CALL getPropertyByName( const ::rtl::OUString& aName ) throw (com::sun::star::beans::UnknownPropertyException, com::sun::star::uno::RuntimeException);
    virtual ::sal_Bool SAL_CALL hasPropertyByName( const ::rtl::OUString& Name ) throw (com::sun::star::uno::RuntimeException);

    // awt::XImageConsumer
    virtual void SAL_CALL init( ::sal_Int32 Width, ::sal_Int32 Height ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setColorModel( ::sal_Int16 BitCount, const com::sun::star::uno::Sequence< ::sal_Int32 >& RGBAPal, ::sal_Int32 RedMask, ::sal_Int32 GreenMask, ::sal_Int32 BlueMask, ::sal_Int32 AlphaMask ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setPixelsByBytes( ::sal_Int32 nX, ::sal_Int32 nY, ::sal_Int32 nWidth, ::sal_Int32 nHeight, const com::sun::star::uno::Sequence< ::sal_Int8 >& aProducerData, ::sal_Int32 nOffset, ::sal_Int32 nScanSize ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setPixelsByLongs( ::sal_Int32 nX, ::sal_Int32 nY, ::sal_Int32 nWidth, ::sal_Int32 nHeight, const com::sun::star::uno::Sequence< ::sal_Int32 >& aProducerData, ::sal_Int32 nOffset, ::sal_Int32 nScanSize ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL complete( ::sal_Int32 Status, const com::sun::star::uno::Reference< com::sun::star::awt::XImageProducer >& xProducer ) throw (com::sun::star::uno::RuntimeException);

    // awt::XButton
    virtual void SAL_CALL addActionListener( const com::sun::star::uno::Reference< com::sun::star::awt::XActionListener >& l ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeActionListener( const com::sun::star::uno::Reference< com::sun::star::awt::XActionListener >& l ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setLabel( const ::rtl::OUString& Label ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setActionCommand( const ::rtl::OUString& Command ) throw (com::sun::star::uno::RuntimeException);

    // awt::XItemEventBroadcaster
    virtual void SAL_CALL addItemListener( const com::sun::star::uno::Reference< com::sun::star::awt::XItemListener >& l ) throw (com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeItemListener( const com::sun::star::uno::Reference< com::sun::star::awt::XItemListener >& l ) throw (com::sun::star::uno::RuntimeException);
};

#endif // LAYOUT_AWT_VCLXPROXY_HXX
